<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Move-to-front Lists</TITLE>
<link href="suif1_94.html" rel=Next>
<link href="suif1_92.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_92.html">previous</A>, <A HREF="suif1_94.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC93" HREF="suif1_toc.html#TOC93">Move-to-front Lists</A></H2>
<P>
<A NAME="IDX662"></A>
<A NAME="IDX663"></A>

</P>
<P>
<A NAME="IDX664"></A>
<A NAME="IDX665"></A>
The move-to-front list class <CODE>mtflist</CODE> is just a minor variation of
the <CODE>glist</CODE> class.  See section <A HREF="suif1_92.html#SEC92">Generic Lists</A>.  The user must provide a
function that compares a list element with some other unspecified
object.  The <CODE>mtflist</CODE> class then provides a <CODE>lookup</CODE> method
that uses the comparison function to search for a particular element.
After every successful lookup, the returned element is moved to the
front of the list.  This works well for applications with good locality.
The <CODE>DECLARE_MTFLIST_CLASS</CODE> macro works just like the
<CODE>DECLARE_LIST_CLASS</CODE> macro, but it generates move-to-front list
classes.  The code for the <CODE>mtflist</CODE> class is in the files
<TT>`mtflist.h'</TT> and <TT>`mtflist.cc'</TT>.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_92.html">previous</A>, <A HREF="suif1_94.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
